/*
 * softalgjni_err.h description
 * begin  : 2017.07.01
 * author : jgq
*/
#ifndef  SOFTALGJNI_ERR_H
#define  SOFTALGJNI_ERR_H

#define  JNI_BASE_ERR         0x07000000
//SM2
/* bw_sm2_sign 函数的错误码 02*/
#define BW_SM2_SIGN_REINPUT_RND                             0x07104121
#define BW_SM2_SIGN_INVALID_PUBKEY                          0x07104122   //pubkey not legal point
/* bw_sm2_verify 函数的错误码 03*/
#define BW_SM2_SIGN_VERIFY_FAILED                           0x07104131   //signature verify failed
#define BW_SM2_VERIFY_INVALID_PUBKEY                        0x07104132   
/* bw_sm2_tps_client_keygen 函数的错误码 04*/
/* bw_sm2_tps_server_keygen 函数的错误码 05*/
/* bw_sm2_tps_client_pubkey_verify 函数的错误码 06*/
#define BW_SM2_TPS_CLIENT_PUBKEY_VERIFY_FAIL                0x07104161
/* bw_sm2_tps_client_init 函数的错误码 07*/
/* bw_sm2_tps_client_hello 函数的错误码 08*/
/* bw_sm2_tps_server_response 函数的错误码 09*/
#define BW_SM2_TPS_SERVER_RESPONSE_REINPUT_RND              0x07104191
/* bw_sm2_tps_client_final 函数的错误码 0a*/
#define BW_SM2_TPS_CLIENT_FINAL_S_IS_ZERO                   0x071041a1
/* bw_sm2_tps_client_clear 函数的错误码 0b*/

/* bw_sm2_query_clen 函数的错误码 01*/
/* bw_sm2_query_mlen 函数的错误码 02*/
/* bw_sm2_enc 函数的错误码 03*/
#define BW_SM2_ENC_S_IS_INF                                 0x07104231
/* bw_sm2_dec 函数的错误码 04*/
#define BW_SM2_DEC_INVALID_C1                               0x07104241
#define BW_SM2_DEC_S_IS_INF                                 0x07104242
#define BW_SM2_DEC_T_IS_ZERO                                0x07104243
#define BW_SM2_DEC_U_UNEQU_C3                                0x07104245
/* bw_sm2_tpe_client_hello 函数的错误码 05*/
#define BW_SM2_TPE_CLIENT_INVALID_POINT                     0x07104251
#define BW_SM2_TPE_CLIENT_S_IS_INF                          0x07104252
/* bw_sm2_tpe_server_response 函数的错误码 06*/
#define BW_SM2_TPE_SERVER_INVALID_POINT                     0x07104261
/* bw_sm2_tpe_client_final 函数的错误码 07*/
#define BW_SM2_TPE_CLIENT_T_IS_ZERO                         0x07104271
#define BW_SM2_TPE_CLIENT_U_UNEQU_C3                        0x07104272
/* 文件 sm2_keyexchange.c ----- 43 */
/* bw_sm2_kx_nocomfirm_sender_final 函数的错误码 01*/
#define BW_SM2_KX_NOCOMFIRM_SENDER_FINAL_INVALID_POINT      0x07104311
#define BW_SM2_KX_NOCOMFIRM_SENDER_FINAL_U_IS0              0x07104312
/* bw_sm2_kx_nocomfirm_responsor 函数的错误码 02*/
#define BW_SM2_KX_NOCOMFIRM_RESPONSOR_INVALID_POINT         0x07104321
#define BW_SM2_KX_NOCOMFIRM_RESPONSOR_V_IS0                 0x07104322
/* bw_sm2_tpkx_nocomfirm_sender_query_server 函数的错误码 03*/
#define BW_SM2_TPKX_NOCOMFIRM_SENDER_INVALID_POINT          0x07104331
/* bw_sm2_tpkx_nocomfirm_sender_final 函数的错误码 04*/
#define BW_SM2_TPKX_NOCOMFIRM_SENDER_FINAL_INVALID_POINT    0x07104341
#define BW_SM2_TPKX_NOCOMFIRM_SENDER_FINAL_U_IS0            0x07104342
/* bw_sm2_tpkx_nocomfirm_responsor_s1 函数的错误码 05*/
#define BW_SM2_TPKX_NOCOMFIRM_RESPONSOR_S1_INVALID_POINT    0x07104351
/* bw_sm2_tpkx_nocomfirm_responsor_final 函数的错误码 06*/
#define BW_SM2_TPKX_NOCOMFIRM_RESPONSOR_FINAL_INVALID_POINT 0x07104361
#define BW_SM2_TPKX_NOCOMFIRM_RESPONSOR_FINAL_U_IS0         0x07104362

#define JNI_SM2_DATALEN_ERROR                               0x07104401   //sm2 jni 数据长度错误
#define JNI_SM2_INBUFF_ERROR                                0x07104402   //sm2 jni 输入缓冲区为NULL
#define JNI_SM2_BUFF_TOO_SMALL                              0x07104403   //sm2 jni 输出缓冲区空间不足


//SM3
#define JNI_SM3_DATALEN_ERROR                               0x07200101   //sm3 hash indata len error   
//SM4
#define JNI_SM4_MODE_ERROR                                  0x07300101   //not encrypt or decrypt mode
#define JNI_SM4_DATALEN_ERROR                               0x07300102   //plain data length error (%16 != 0)
#define JNI_SM4_IVLEN_ERROR                                 0x07300103   //iv len != 16
#define JNI_SM4_SYMMKEYLEN_ERRORR                           0x07300104   //对称密钥长度!= 16
#define JNI_SM4_UNPADDING_ERRORR                            0x07300105   //去除补码错误


//SM9
/* 文件 random.c -----02  */
/* sm9_random_from_bytes 函数的错误码 */
#define IBE_EC_RND_FROM_BYTES_RND_TOO_SHORT         0x07110201


/* 文件 kgc.c ------03 */
/* sm9_core_kgc_gen_user_key_s 函数的错误码 */
#define IBE_EC_KGC_REBUILD_MASTER_KEY_S               0x07110301
/* sm9_core_kgc_gen_user_key_e 函数的错误码 */
#define IBE_EC_KGC_REBUILD_MASTER_KEY_E               0x07110302
/* 文件 enc.c  -------06 */
/* sm9_core_enc_sm4 函数的错误码 */
#define IBE_EC_CORE_ENC_SM4_INVALID_MLEN               0x07110601
/* sm9_core_dec_sm4 函数的错误码 */
#define IBE_EC_CORE_DEC_SM4_INVALID_CLEN               0x07110611
/* sm9_core_dec 函数的错误码 */
#define IBE_EC_CORE_DEC_INVALID_POINT                  0x07110621
#define IBE_EC_CORE_DEC_KEY_IS_ZERO                    0x07110622
#define IBE_EC_CORE_DEC_INVALID_MAC                    0x07110623
/* 文件 key_encapsule.c -------0d */
/* sm9_core_key_encapsule 函数的错误码 */
//no error
/* sm9_core_key_unencapsule 函数的错误码 */
#define IBE_EC_CORE_KEY_UNENCAPSULE_NOT_VALID_POINT        0x07110d01
#define IBE_EC_CORE_KEY_UNENCAPSULE_K_IS_ALL_ZERO          0x07110d02

/* 文件 key_exchange.c -------0e */
/* sm9_key_exchange_sender_cpt 函数的错误码 */
#define IBE_EC_KEYEXCH_SENDER_CHECK_FAIL                    0x07110e01
#define IBE_EC_KEYEXCH_SENDER_CPT_INVALID_POINT             0x07110e02
/* sm9_key_exchange_responsor_rb 函数的错误码 */
#define IBE_EC_KEYEXCH_RESPONSOR_RB_INVALID_POINT           0x07110e11
/* sm9_key_exchange_responsor_check 函数的错误码 */
#define IBE_EC_KEYEXCH_RESPONSOR_CHECK_FAIL                 0x07110e21

/* 文件 sign.c ------- 13 */
/* sm9_core_verify_final 函数的错误码 */
#define IBE_EC_CORE_SIGN_VERIFY_FAIL                         0x07111301


/* 文件 bw_ibe_sm9.c ------40 */
/* bw_ibe_sm9_kgc_gen_user_private_key_ds 函数的错误码 */
#define IBE_EC_GEN_UKEY_DS_REBUILD_ALL_KEYS           0x07114001
/* bw_ibe_sm9_kgc_gen_user_private_key_de 函数的错误码 */
#define IBE_EC_GEN_UKEY_DE_REBUILD_ALL_KEYS           0x07114011
#define IBE_EC_GEN_UKEY_DE_INVALID_TYPE               0x07114012
/* bw_ibe_sm9_sign_init 函数的错误码 */
//#define IBE_EC_SIGN_INIT_REINPUT_RND                    0x07114021
/* bw_ibe_sm9_verify_final 函数的错误码 */
#define IBE_EC_SIGN_VERIFY_FAIL                        0x07114031       
/* bw_ibe_sm9_key_encapsule 函数的错误码 */
#define IBE_EC_KEY_ENCAPSULE_KLEN_TOO_BIG               0x07114041
/* bw_ibe_sm9_key_unencapsule 函数的错误码 */
#define IBE_EC_KEY_UNENCAPSULE_KLEN_TOO_BIG           0x07114051
#define IBE_EC_KEY_UNENCAPSULE_NOT_VALID_POINT        0x07114052
#define IBE_EC_KEY_UNENCAPSULE_K_IS_ALL_ZERO          0x07114053
/* bw_ibe_sm9_enc_query_length 函数的错误码 */
#define IBE_EC_ENC_GET_LENGTH_INVALID_TYPE            0x07114061
#define IBE_EC_ENC_GET_LENGTH_INVALID_IN_LENGTH       0x07114062
/* bw_ibe_sm9_enc_sm4 函数的错误码 */
#define IBE_EC_ENC_SM4_INVALID_MLEN                   0x07114071
/* bw_ibe_sm9_dec_sm4 函数的错误码 */
#define IBE_EC_DEC_SM4_INVALID_CLEN                   0x07114081



/* 文件 bw_ibe_sm9_two_parts_sign.c ------41 */
/* bw_ibe_sm9_tps_kgc_gen_keys_m\bw_ibe_sm9_tps_kgc_gen_keys_a 函数的错误码 */
#define IBE_EC_TPS_KGC_REBUILD_MASTER_KEY            0x07114101
/* bw_ibe_sm9_tps_kgc_gen_keys_m 函数的错误码 */
/* bw_ibe_sm9_tps_kgc_gen_keys_a 函数的错误码 */


/* 文件 bw_ibe_sm9_two_parts_enc.c ------42 */
/* bw_ibe_sm9_tpe_kgc_gen_keys_m\bw_ibe_sm9_tpe_kgc_gen_keys_a 函数的错误码 */
#define IBE_EC_TPE_KGC_REBUILD_MASTER_KEY            0x07114201
/* bw_ibe_sm9_tpe_user_hello_m 函数的错误码 */
#define IBE_EC_TPE_USER_HELLO_INVALID_C1            0x07114211
/* bw_ibe_sm9_tpe_server_response_m 函数的错误码 */
#define IBE_EC_TPE_SERVER_RESPONSE_INVALID_C1       0x07114221
/* bw_ibe_sm9_tpe_user_final_kdf_m 函数的错误码 */
#define IBE_EC_TPE_FINAL_KDF_M_INVALID_C1             0x07114231
#define IBE_EC_TPE_FINAL_KDF_M_K_ALLZERO              0x07114232
#define IBE_EC_TPE_FINAL_KDF_M_INVALID_MAC            0x07114233
/* bw_ibe_sm9_tpe_user_final_sm4_m 函数的错误码 */
#define IBE_EC_TPE_FINAL_SM4_M_INVALID_C1             0x07114241
#define IBE_EC_TPE_FINAL_SM4_M_K_ALLZERO              0x07114242
#define IBE_EC_TPE_FINAL_SM4_M_INVALID_MAC            0x07114243
#define IBE_EC_TPE_FINAL_SM4_M_INVALID_CLEN           0x07114244
/* bw_ibe_sm9_tpe_user_final_kdf_a 函数的错误码 */
#define IBE_EC_TPE_FINAL_KDF_A_INVALID_C1             0x07114251
#define IBE_EC_TPE_FINAL_KDF_A_K_ALLZERO              0x07114252
#define IBE_EC_TPE_FINAL_KDF_A_INVALID_MAC            0x07114253
/* bw_ibe_sm9_tpe_user_final_sm4_a 函数的错误码 */
#define IBE_EC_TPE_FINAL_SM4_A_INVALID_C1             0x07114261
#define IBE_EC_TPE_FINAL_SM4_A_K_ALLZERO              0x07114262
#define IBE_EC_TPE_FINAL_SM4_A_INVALID_MAC            0x07114263
#define IBE_EC_TPE_FINAL_SM4_A_INVALID_CLEN           0x07114264


/* 文件 bw_ibe_sm9_two_parts_key_encapsule.c ------43 */
/* bw_ibe_sm9_tpke_user_hello_m/a 函数的错误码 */
#define IBE_EC_TPKE_USER_HELLO_INVALID_C1            0x07114301
/* bw_ibe_sm9_tpke_server_response_m/a 函数的错误码 */
#define IBE_EC_TPKE_SERVER_RESPONSE_INVALID_C1       0x07114311
/* bw_ibe_sm9_tpke_user_final_m 函数的错误码 */
#define IBE_EC_TPKE_FINAL_M_INVALID_C1              0x07114321
#define IBE_EC_TPKE_FINAL_M_K_ALLZERO               0x07114322
#define IBE_EC_TPKE_FINAL_M_KLEN_TOO_BIG            0x07114323


#define JNI_SM9_DATALEN_ERROR                      0x07105001
#define JNI_SM9_CTXLEN_ERROR                       0x07105002      //sm9 context len error,!= sizeof(struct ctx)
#define JNI_SM9_INBUFF_ERROR                       0x07104402   //sm9 jni 输入缓冲区为NULL
#define JNI_SM9_BUFF_TOO_SMALL                     0x07104403   //sm9 jni 输出缓冲区空间不足






#endif   //SOFTALGJNI_ERR_H